// global variables ------------------------------------------------------------
var ife_Preferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var ife_FormHistory = 0;
if ("nsIFormHistory" in Components.interfaces)
 ife_FormHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory);
if ("nsIFormHistory2" in Components.interfaces)
 ife_FormHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory2);

var ife_On = ife_GetPrefInt("InFormEnter.On", 1);
var ife_OptionsPlacement = ife_GetPrefInt("InFormEnter.OptionsPlacement", 0);
var ife_MarkerRightClick = ife_GetPrefInt("InFormEnter.MarkerRightClick", 0);
var ife_MarkersMode = ife_GetPrefInt("InFormEnter.MarkersMode", 1);
var ife_ColorizeItems = ife_GetPrefInt("InFormEnter.ColorizeItems2", 0);

var ife_MenuSet = "";
var ife_MenuSetDefault = "";
var ife_MenuItemsCount = 0;

// dummy debug dump ------------------------------------------------------------------
function ddd(msg) {
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                       .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("_" + msg + "_");
}

//------------------------------------------------------------------------------
function ife_GetPrefInt(prefName, prefDefault)
{
 if (!ife_Preferences.prefHasUserValue(prefName))
  ife_Preferences.setIntPref(prefName, prefDefault);
 return ife_Preferences.getIntPref(prefName);
}

//------------------------------------------------------------------------------
function ife_GetPrefChar(prefName, prefDefault)
{
 if (!ife_Preferences.prefHasUserValue(prefName))
  ife_Preferences.setCharPref(prefName, prefDefault);
 return ife_Preferences.getCharPref(prefName);
}

//------------------------------------------------------------------------------
function ife_GetPropStr(id)
{
 var ife_strings = document.getElementById("ife_sb");
 return ife_strings.getString (id);
}

//------------------------------------------------------------------------------
function ife_CheckDefaultProfile()
{
 var ife_strings = document.getElementById("ife_sb");

 ife_MenuSetDefault = "";
 for (var s=1; s<=8; s++)
  ife_MenuSetDefault += (ife_strings.getString ("ife.default.line."+s) + "\n");

 ife_MenuSet = ife_GetPrefChar("InFormEnter.1.MenuSet", escape(ife_MenuSetDefault));

 ife_GetPrefChar("InFormEnter.Profiles", escape(ife_strings.getString ("ife.default.profile")) + "\t1");
 ife_GetPrefInt("InFormEnter.ProfileCurrent", 1);
 ife_GetPrefInt("InFormEnter.ProfileNext", 2);
}

//------------------------------------------------------------------------------
function ife_RandInt()
{
 return Math.round (Math.random()*10000);
}

//------------------------------------------------------------------------------
function ife_RandChar()
{
 var x, y;

 x = ife_RandInt() % 3;

 if (x == 2)
  y = 48 + (ife_RandInt() % 10);

 if (x == 1)
  y = 97 + (ife_RandInt() % 26);

 if (x == 0)
  y = 65 + (ife_RandInt() % 26);

 return String.fromCharCode(y);
}

//------------------------------------------------------------------------------
function ife_HideSharp(str)
{
 str = str.replace(/##/g, "\t");
 return str;
}

//------------------------------------------------------------------------------
function ife_UnhideSharp(str)
{
 str = str.replace(/\t/g, "#");
 return str;
}

//------------------------------------------------------------------------------
function ife_HideAt(str)
{
 str = str.replace(/@@/g, "\n");
 return str;
}

//------------------------------------------------------------------------------
function ife_UnhideAt(str)
{
 str = str.replace(/\n/g, "@@");
 return str;
}

//------------------------------------------------------------------------------
function ife_GetElementXY (element) 
{
 var offsetLeft = 0;
 var offsetTop = 0;
 while (element)
 {
  offsetLeft += element.offsetLeft;
  offsetTop += element.offsetTop;
  element = element.offsetParent;
 }
 
 if (navigator.userAgent.indexOf("Mac") != -1 && typeof document.body.leftMargin != "undefined")
 {
  offsetLeft += document.body.leftMargin;
  offsetTop += document.body.topMargin;
 }

 return {x:offsetLeft, y:offsetTop};
}

//------------------------------------------------------------------------------
function ife_GetClientX (element)
{
  var result = 0;
  if (element.offsetParent != null)
   result = ife_GetClientX (element.offsetParent);
  result += element.offsetLeft;

  return result;
}

//------------------------------------------------------------------------------
function ife_GetClientY (element)
{
  var result = 0;
  if (element.offsetParent != null)
   result = ife_GetClientY (element.offsetParent);
  result += element.offsetTop;

  return result;
}

//------------------------------------------------------------------------------
var ife_LastPassword = "";

function ife_Macro(command, runMode)
{
 var result = ife_GetPropStr("ife.msg.macro.text");
 var tmp = command.split (":");

 if (tmp.length == 1) // macro without params
 {
  result = ife_GetPropStr("ife.msg.macro.name");
  if (tmp[0] == "RLP")
   result = ife_LastPassword;
  else
  if (tmp[0] == "SR")
   result = "#SR#";
 }

 if (tmp.length == 2) // macro with params
 {
  result = ife_GetPropStr("ife.msg.macro.name");
  if (tmp[0] == "GP")
  {
   result = ife_GetPropStr("ife.msg.macro.arguments");
   var param = parseInt (tmp[1]);
   if (param > 0 && param < 33)
   {
    result = "";
    var i=0;
    do
    {
     result += ife_RandChar();
     i++;
    }while(i<param);

    if (runMode)
     ife_LastPassword = result;
   }
  }
 }

 return ife_HideAt(ife_UnhideSharp(result));
}

//------------------------------------------------------------------------------
function ife_StrMaxInputLength(maxlength)
{
 var result; 
 if (maxlength == null)
  result = ife_GetPropStr("ife.msg.field.length.unknown");
 else
  result = ife_GetPropStr("ife.msg.field.length") + " " + maxlength;
 return result;
}

//------------------------------------------------------------------------------
function ife_CheckMenuItemLength(menu_name)
{
 var maxLength = 37;
 var textShort = menu_name;
 if (textShort.length > maxLength)
 {
  var sepText = "[...]"; // must be shorter maxLength
  var pos1 = (maxLength-sepText.length)/2;
  textShort = menu_name.substring(0, pos1);
  textShort += sepText;
  var pos2 = menu_name.length-pos1;
  textShort += menu_name.substring(pos2);
 }

 return textShort;
}

//------------------------------------------------------------------------------

function ife_IsStrInFormCache(inputName, str)
{
 if(ife_FormHistory && ife_On && ife_ColorizeItems)
  return ife_FormHistory.entryExists(inputName, str);
 return false;
}

//------------------------------------------------------------------------------

function ife_IsInputVisibleAndEditable(input)
{
 if (input && input.style && input.style.display && input.style.display == "none")
  return false;

 if (input && input.style && input.style.visibility && 
     (input.style.visibility == "hidden" || input.style.visibility == "collapse"))
  return false;

 if (input && (input.disabled || input.readOnly))
  return false;

 return true;
}

//------------------------------------------------------------------------------

function ife_ParseMenuLine(line)
{
 var menu_name = "";
 var menu_value = "";
 if (line.length > 0)
 {
   line = ife_HideSharp(line);
   var tmp = line.split ("#");
   if (tmp.length > 1)
   {
     var arraySize = tmp.length;
     if (arraySize == 2) // no macros
     {
      menu_name = ife_UnhideSharp(tmp[1]);
      menu_value = ife_HideAt(ife_UnhideSharp(tmp[0]));
     }
     else
     {
      menu_name = ife_UnhideSharp(tmp[arraySize-1]);
      menu_value = ife_Macro(tmp[arraySize-2], false);
     }
   }
   else 
   {
     menu_name = ife_UnhideSharp(line);
     menu_value = ife_HideAt(ife_UnhideSharp(line));
   }
 }
 var result = new Array(menu_name, menu_value);
 return result;
}

//------------------------------------------------------------------------------

function ife_GetCurrentProfileItemsCountInFormCache(inputName)
{
 var itemsCount = 0;
 if(ife_FormHistory && ife_On && ife_ColorizeItems)
 {
  var profileId = ife_GetPrefInt("InFormEnter.ProfileCurrent", 1);
  ife_MenuSet = ife_GetPrefChar("InFormEnter."+profileId+".MenuSet", "");

  var menuTextItems = unescape(ife_MenuSet).split("\n"); 
  var lines_count = menuTextItems.length;
  for (var i=0; i<lines_count; i++)
  {
   var resultArray = ife_ParseMenuLine(menuTextItems[i]);
   var menu_value = resultArray[1];
   if(ife_IsStrInFormCache(inputName, menu_value))
    itemsCount++;
  }
 }
 return itemsCount;
}

//------------------------------------------------------------------------------

function ife_GetCurrentProfileFirstItemFromFormCache(inputName)
{
 if(ife_FormHistory && ife_On && ife_ColorizeItems)
 {
  var profileId = ife_GetPrefInt("InFormEnter.ProfileCurrent", 1);
  ife_MenuSet = ife_GetPrefChar("InFormEnter."+profileId+".MenuSet", "");

  var menuTextItems = unescape(ife_MenuSet).split("\n"); 
  var lines_count = menuTextItems.length;
  for (var i=0; i<lines_count; i++)
  {
   var resultArray = ife_ParseMenuLine(menuTextItems[i]);
   var menu_value = resultArray[1];
   if(ife_IsStrInFormCache(inputName, menu_value))
   {
    return menu_value;
   }
  }
 }
 return "";
}

//------------------------------------------------------------------------------
function ife_PopupFill(menuitemID, inputName, inputMaxLength)
{
 ife_CheckDefaultProfile();

 // ??? ife_common.js::ife_MenuSet != ife_options.js::ife_MenuSet  
 var profileId = ife_GetPrefInt("InFormEnter.ProfileCurrent", 1);
 ife_MenuSet = ife_GetPrefChar("InFormEnter."+profileId+".MenuSet", "");
 var toShowSize = ife_GetPrefInt("InFormEnter."+profileId+".ShowSize", 0);
 ife_MenuItemsCount = 0;
 var mi_from_form_cache_last = null;
 var mi_from_form_cache_count = 0;

 var mi_hint = document.getElementById(menuitemID);
 var mi_sep = mi_hint.nextSibling.nextSibling;

 // remove previous menu
 while (mi_sep.nextSibling != null)
  mi_sep.parentNode.removeChild (mi_sep.nextSibling);

 // template
 var mi_template = mi_hint.cloneNode(true);
 mi_template.setAttribute("disabled", false);

 // create new items
 var menuTextItems = unescape(ife_MenuSet).split("\n"); 
 var lines_count = menuTextItems.length;
 for (var i=0; i<lines_count; i++)
 {
   var line = menuTextItems[i];
   var resultArray = ife_ParseMenuLine(line);
   var menu_name = resultArray[0];
   var menu_value = resultArray[1];

   if (menu_name != "" && menu_value != "#SR#")
   {
     var mi_new = mi_template.cloneNode(true);
     mi_new.setAttribute("label", ife_CheckMenuItemLength(menu_name));
     if (toShowSize)
      mi_new.setAttribute("acceltext", "["+menu_value.length+"]");
     mi_new.setAttribute("oncommand", "ife_OnMenuItemSelect(" + i + ", event);");
     if (ife_IsStrInFormCache(inputName, menu_value))
     {
      mi_new.setAttribute("image", "chrome://informenter/skin/arrow_inhistory.png");
      mi_from_form_cache_last = mi_new;
      mi_from_form_cache_count++;
     }
     mi_hint.parentNode.appendChild (mi_new);
     ife_MenuItemsCount++;
   }
   if (menu_value == "#SR#")
   {
     var mi_new_sep = mi_sep.cloneNode(true);
     mi_new_sep.setAttribute("hidden", false);
     mi_hint.parentNode.appendChild (mi_new_sep);
   }
 }

 // hint
 var hint_label; 
 if (ife_MenuItemsCount == 0)
   hint_label = ife_GetPropStr("ife.msg.setup"); 
 else
   hint_label = ife_StrMaxInputLength (inputMaxLength);
 mi_hint.setAttribute("label", hint_label);

 // check form cache count
 if(mi_from_form_cache_count == 1)
  mi_from_form_cache_last.setAttribute("image", "chrome://informenter/skin/arrow_inhistory_one.png");

 // separator
 mi_sep.setAttribute("hidden", (ife_MenuItemsCount == 0));
}
